<?
/***********************************************
Emergency Message System (EMS)
Created by Nitemare
http://www.nitemare.ca

beta tested by Jan

Releace date: aug 15th 2008

************************************************/
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook("global_start", "EMS_globals");
$plugins->add_hook("admin_config_menu", "EMS_nav");
$plugins->add_hook("admin_config_action_handler", "EMS_actionhandler");
$plugins->add_hook("admin_load", "EMS_admin");

function ems_info()
{
	return array(
		"name"		=> "Emergency Message System",
		"description"	=> "This Pluging will display a message to users on every page or just the index page, based on the settings you set.",
		"website"		=> "http://nitemare.ca",
		"author"		=> "Nitemare",
		"authorsite"	=> "http://nitemare.ca",
		"version"		=> "4.1.3",
		"guid" 			=> "",
		"compatibility" => "16*"
	);
}

function EMS_install(){
	global $db;
	
	$db->query("CREATE TABLE `".TABLE_PREFIX."ems` ( `eid` int(11) NOT NULL auto_increment, `message` varchar(255) NOT NULL, `type` varchar(100) NOT NULL, `index` tinyint(1) NOT NULL default '1', `author` int(10) NOT NULL, `created` int(25) NOT NULL, `order` smallint(10) NOT NULL default '1', PRIMARY KEY (`eid`) ) ENGINE=MyISAM");
	
	$boardmsg_text_template = array(
		"title"		=> "boardmessage_styles",
		"template"	=> '<style type="text/css">
.alert_yellow {
background: #FFF6BF;
border-top: 2px solid #FFD324;
border-bottom: 2px solid #FFD324;
text-align: center;
margin: 10px auto;
padding: 5px 20px;
}

.alert_blue {
background: #ADCBE7;
border-top: 2px solid #0F5C8E;
border-bottom: 2px solid #0F5C8E;
text-align: center;
margin: 10px auto;
padding: 5px 20px;
}

.alert_red {
background: #FFB2B2;
border-top: 2px solid #FF4444;
border-bottom: 2px solid #FF4444;
text-align: center;
margin: 10px auto;
padding: 5px 20px;
}

.alert_green {
background: #D6ECA6;
border-top: 2px solid #8DC93E;
border-bottom: 2px solid #8DC93E;
text-align: center;
margin: 10px auto;
padding: 5px 20px;
}
.alert_black {
background: #B2B2B2;
border-top: 2px solid #383838;
border-bottom: 2px solid #383838;
text-align: center;
margin: 10px auto;
padding: 5px 20px;
}
.alert_purple {
background: #E0B2FF;
border-top: 2px solid #802F99;
border-bottom: 2px solid #802F99;
text-align: center;
margin: 10px auto;
padding: 5px 20px;
}
.alert_orange {
background: #FFC57F;
border-top: 2px solid #FF8C00;
border-bottom: 2px solid #FF8C00;
text-align: center;
margin: 10px auto;
padding: 5px 20px;
}
.alert_light_blue {
background: #9BFFFF;
border-top: 2px solid #0F9999;
border-bottom: 2px solid #0F9999;
text-align: center;
margin: 10px auto;
padding: 5px 20px;
}
</style>',
		"sid"		=> "-1",
	);
	
	$db->insert_query("templates", $boardmsg_text_template);
}
function EMS_is_installed()
  {
 		global $db;
 		if($db->table_exists("ems")){
   		return true;
 		}
 		return false;
}
function EMS_activate(){	
	require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	find_replace_templatesets(
		"header",
		'#'.preg_quote('<navigation>').'#',
		'<navigation><br />
{$messagestyle}{$boardmessage}'
	);
}
function EMS_deactivate(){	
	require MYBB_ROOT.'/inc/adminfunctions_templates.php';	
	find_replace_templatesets(
		"header",
		'#'.preg_quote('<navigation><br />
{$messagestyle}{$boardmessage}').'#',
		'<navigation>',
		0
	);
}

function EMS_uninstall()
  {
 		global $db;
		$db->drop_table("ems");
		$db->delete_query("templates", "title = 'boardmessage_styles'");
}
function EMS_globals(){
	global $db, $mybb, $templates, $boardmessage, $messagestyle;
	
	$query = $db->query("SELECT * FROM ".TABLE_PREFIX."ems ORDER BY `order` ASC");
	
				$sql = Array();
			While ($row = $db->fetch_array($query)){
				$sql[]= $row;
			}
			$mess = $sql;
	
	if (count($mess) != 0 ){	
		for ($i=0; $i <= $db->num_rows($query)-1; $i++) { 
			if ($mess[$i]['index'] == true){
				if ($_SERVER['SCRIPT_FILENAME'] == MYBB_ROOT."index.php"){
					$message = $message."<P class=alert_".$mess[$i]['type'].">".$mess[$i]['message']."</P>";
				}
			}else{
				$message = $message."<P class=alert_".$mess[$i]['type'].">".$mess[$i]['message']."</P>";
			}
		 }
	}
	eval("\$messagestyle = \"".$templates->get("boardmessage_styles")."\";");
	$boardmessage = doEMSsmilies($message);
	
}

function doEMSsmilies($message, $url="")
{
	global $db, $cache;

	if($url != "")
	{
		if(substr($url, strlen($url) -1) != "/")
		{
			$url = $url."/";
		}
	}
	
	$smiliecache = $cache->read("smilies");
	if(is_array($smiliecache))
	{
		reset($smiliecache);
		foreach($smiliecache as $sid => $smilie)
		{
			$message = str_replace($smilie['find'], "<img src='".$url.$smilie['image']."' align='middle' border='0' alt='".$smilie['name']."' />", $message);
		}
	}
	return $message;
}

function EMS_nav($sub_menu){

        $sub_menu[] = array(
                      "id" => "ems",
                      "title" => "EMS Alert",
                      "link" => "index.php?module=config/ems"
                      );
}

function EMS_actionhandler(&$action)
{
        $action['ems'] = array('active' => 'ems', 'file' => '');
    }
    
function EMS_admin(){
	
	global $mybb, $db, $page, $lang;
	
	require_once("../inc/functions_time.php");
	
	if($page->active_action != "ems")
	{
		return;
	}
	if ($mybb->input['add']){
		
    	$page->add_breadcrumb_item("EMS system");
   		$page->output_header("EMS Alert system");
		
		add_form();
   		 
        $page->output_footer();
        exit;
	}elseif ($mybb->input['do_add']){
		
    	$page->add_breadcrumb_item("EMS system");
   		$page->output_header("EMS Alert system");
   		
		if (!$mybb->input['message']){
			flash_message("You must enter a message", 'error');
		    add_form();
		}elseif (!$mybb->input['type']){
			flash_message("You must select an alert type", 'error');
			add_form($mybb->input['message']);
		}elseif (!$mybb->input['local']){
			flash_message("You must select an alert location", 'error');
			add_form($mybb->input['message']);
		}else{
			if ($mybb->input['local'] == "index"){
				$index = true;
			}else if ($mybb->input['local'] == "whole"){
				$index = false;
			} 	
			$time = adodb_getdate();
			$stuff = Array(
			"message" => $db->escape_string($mybb->input['message']),
			"type" => $mybb->input['type'],
			"order" => revert_nums($mybb->input['order']),
			"created" => $time[0],
			"index" => $index,
			"author" => $mybb->user['uid']);
			$db->insert_query("ems", $stuff);
			
			flash_message("Message added sucessfully.", 'success');
		    admin_redirect("index.php?module=config/ems");
		}
			
		
        $page->output_footer();
        exit;

	}elseif ($mybb->input['edit']){
			
		
    	$page->add_breadcrumb_item("EMS system");
   		$page->output_header("EMS Alert system");
   		
   		edit_form();
        
        $page->output_footer();
        exit;	
	}elseif ($mybb->input['do_edit']){
				
    	$page->add_breadcrumb_item("EMS system");
   		$page->output_header("EMS Alert system");
		if (!$mybb->input['message']){
			flash_message("You must enter a message", 'error');
   			edit_form();
		}elseif (!$mybb->input['type']){			
			flash_message("You must select an alert type", 'error');
   			edit_form();
		}elseif (!$mybb->input['local']){
			flash_message("You must select an alert location", 'error');
			add_form($mybb->input['message']);
		}else{
			if ($mybb->input['local'] == "index"){
				$index = true;
			}else if ($mybb->input['local'] == "whole"){
				$index = false;
			}
			$stuff = Array(
			"message" => $db->escape_string($mybb->input['message']),
			"order" => revert_nums($mybb->input['order']),
			"type" => $mybb->input['type'],
			"index" => $index);
			$db->update_query("ems", $stuff, "eid = '".$mybb->input['eid']."'");
			
			flash_message("Ogłoszenie o ID:".$mybb->input['eid']." zostało zedytowane poprawnie.", 'success');
		    admin_redirect("index.php?module=config/ems");
		}
		
        $page->output_footer();
        exit;	
	}elseif ($mybb->input['delete']){
		
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."ems WHERE eid = '".$mybb->input['eid']."'");
		
		$message = $db->fetch_array($query);		
		
    	$page->add_breadcrumb_item("EMS system");
   		$page->output_header("EMS Alert system");
		
        $form = new Form("index.php?module=config/ems", "post");
   		
		$table = new Table;     
    	$table->construct_header("Delete Alert",array('class' => 'align_center', 'colspan' => 1));
		
    	
    	$table->construct_cell("Are you sure you want to delete the message with ID:".$message['eid']." and starting: ".turn($message['message']),array('class' => 'align_center'));
    	$table->construct_row();
    		    	                        
        $table->construct_cell($form->generate_hidden_field('eid', $message['eid']).
                        	$form->generate_submit_button("Delete", array('name' => 'do_delete'))
                        	." ".
                        	$form->generate_submit_button("Cancel", array('name' => 'cancel'))               
                        	,array('class' => 'align_center'));
                        $table->construct_row();
    	
    $table->output("<center>Emergency Message System</center>");
		
        $form->end();
        
        $page->output_footer();
        exit;
	}elseif ($mybb->input['do_delete']){
		
			$db->delete_query("ems", "eid = '".$mybb->input['eid']."'");
			
			flash_message("Message with ID:".$mybb->input['eid']." deleted sucessfully.", 'success');
		    admin_redirect("index.php?module=config/ems");
	}else{
		
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."ems");
	
				$sql = Array();
			While ($row = $db->fetch_array($query)){
				$sql[]= $row;
			}
			$mess = $sql;
			
    $page->add_breadcrumb_item("EMS system");
    $page->output_header("EMS Alert system");
	
	$table = new Table;     
    $table->construct_header("EMS Current Alerts",array('class' => 'align_center', 'colspan' => 6));
    
        $form = new Form("index.php?module=config/ems", "post");
        
                        $table->construct_cell("ID ogłoszenia",array('class' => 'align_center','width' => '65'));
                        $table->construct_cell("Treść ogłoszenia",array('class' => 'align_center'));
                        $table->construct_cell("Kolejność wyświetlania", array('class' => 'align_center','width' => '100'));
                        $table->construct_cell("Typ i kolor", array('class' => 'align_center','width' => '100'));
                        $table->construct_cell("Utworzono", array('class' => 'align_center','width' => '175'));
                        $table->construct_cell("Autor", array('class' => 'align_center','width' => '250'));
                        $table->construct_row();
	                for ($i = 0; $i <= count($mess)-1; $i++) {
		                
		                switch($mess[$i]['type']){
			                Case "yellow":
			                	$colour = "#FFF6BF";
			                	break;
			                Case "blue":
			                	$colour = "#ADCBE7";
			                	break;
			                Case "red":
			                	$colour = "#FFB2B2";
			                	break;
			                Case "green":
			                	$colour = "#D6ECA6";
			                	break;
			                Case "black":
			                	$colour = "#B2B2B2";
			                	break;
			                Case "purple":
			                	$colour = "#E0B2FF";
			                	break;
			                Case "orange":
			                	$colour = "#FFC57F";
			                	break;
			                Case "light_blue":
			                	$colour = "#9BFFFF";
			                	break;
						}
		                switch($mess[$i]['index']){
			                Case true:
			                	$index = "Index Only";
			                	break;
			                Case false:
			                	$index = "Whole site";
			                	break;
		                	}
						
		                	
                        $table->construct_cell($form->generate_radio_button("eid", $mess[$i]['eid'], $mess[$i]['eid']),array('class' => 'align_center','style' => 'background: '.$colour.';', 'width' => '75'));
                        $table->construct_cell(doEMSsmilies($mess[$i]['message'],"../"),array('class' => 'align_center','style' => 'background: '.$colour.';'));
                        $table->construct_cell($mess[$i]['order'],array('class' => 'align_center','style' => 'background: '.$colour.';'));
                        $table->construct_cell(ucfirst($mess[$i]['type'])."<br />".$index,array('class' => 'align_center','style' => 'background: '.$colour.';','width' => '100'));
                        $user = get_user($mess[$i]['author']);
                        //adodb_date()
                        //$mess[$i]['created']
                        $temp = adodb_getdate();
                        $table->construct_cell( adodb_date("d/m/Y h:i:s A",$mess[$i]['created']),array('class' => 'align_center','style' => 'background: '.$colour.';','width' => '175'));
                        $table->construct_cell($user['username'],array('class' => 'align_center','style' => 'background: '.$colour.';','width' => '250'));

                        $table->construct_row();
                }                        
                $table->construct_cell(
                        	$form->generate_submit_button("Dodaj", array('name' => 'add'))
                        	." ".
                        	$form->generate_submit_button("Edytuj", array('name' => 'edit'))
                        	." ".
                        	$form->generate_submit_button("Usuń", array('name' => 'delete'))
                        	,array('colspan' => '6','class' => 'align_center'));
                        $table->construct_row();
		
    $table->output("<center>Emergency Message System</center>");
	
        $form->end();
    
        $page->output_footer();
        exit;
    }
    
}    

function turn($data, $length="25"){
	if (strlen($data) >= $length){
		return substr($data,0,$length-3)."...";		
	}else{
		return $data;
	}

} 
function Add_form($message_text = ""){
	global $db, $mybb, $page;

$form = new Form("index.php?module=config/ems", "post");
   		
		$table = new Table;     
    	$table->construct_header("Add Alert",array('class' => 'align_center', 'colspan' => 1));
		
    	$table->construct_cell($form->generate_text_area("message",$message_text),array('class' => 'align_center'));
    	$table->construct_row();
    	
    	$options = "<option value='red'>Red</option>";
    	$options .= "<option value='blue'>Blue</option>";
    	$options .= "<option value='green'>Green</option>";
    	$options .= "<option value='yellow'>Yellow</option>";
    	$options .= "<option value='black'>Black</option>";
    	$options .= "<option value='purple'>Purple</option>";
    	$options .= "<option value='orange'>Orange</option>";
    	$options .= "<option value='light_blue'>Light Blue</option>";
		
    	$table->construct_cell("Położenie ogłoszenia: ".$form->generate_radio_button("local","index","IStrona główna",Array("checked" => 1))." ".$form->generate_radio_button("local","whole","Każda strona")."<br /> Kolor: <select name='type'> <option value=''>-------------</option>$options</select>  &nbsp;&nbsp;Display Order: <select name='order'>".select_order_options($mess[$i]['order'])."</select>",array('class' => 'align_center'));
    	$table->construct_row();    	                        
    	
        $table->construct_cell(
                        	$form->generate_submit_button("Add", array('name' => 'do_add'))
                        	." ".
                        	$form->generate_reset_button("Reset", array('name' => 'reset'))               
                        	,array('class' => 'align_center'));
                        $table->construct_row();
    	
    $table->output("<center>Emergency Message System</center>");
		
        $form->end();
    }

    
function edit_form(){
	
	global $db, $mybb, $page;
			
		if (!$mybb->input['eid']){
			flash_message("Najpierw musisz zaznaczyć ogłoszenie.", 'error');
		    admin_redirect("index.php?module=config/ems");
	    }
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."ems WHERE eid = '".$mybb->input['eid']."'");
		
		$message = $db->fetch_array($query);		
		
        $form = new Form("index.php?module=config/ems", "post");
   		
		$table = new Table;     
    	$table->construct_header("Edit Alert, Id:".$mybb->input['eid'],array('class' => 'align_center', 'colspan' => 1));
		
    	
    	$table->construct_cell($form->generate_text_area("message", $message['message']),array('class' => 'align_center'));
    	$table->construct_row();
    	if ($message["type"] == "red"){
    		$options .= "<option value='red' Selected>Red</option>";
		}else{
    		$options .= "<option value='red'>Red</option>";
		}
		if ($message["type"] == "blue"){
    		$options .= "<option value='blue' Selected>Blue</option>";
		}else{
    		$options .= "<option value='blue'>Blue</option>";
		}
    	if ($message["type"] == "green"){
    		$options .= "<option value='green' Selected>Green</option>";
		}else{
    		$options .= "<option value='green'>Green</option>";
		}
    	if ($message["type"] == "yellow"){
    		$options .= "<option value='yellow' Selected>Yellow</option>";
		}else{
    		$options .= "<option value='yellow'>Yellow</option>";
		}
    	if ($message["type"] == "black"){
    		$options .= "<option value='black' Selected>Black</option>";
		}else{
    		$options .= "<option value='black'>Black</option>";
		}
		if ($message["type"] == "purple"){
    		$options .= "<option value='purple' Selected>Purple</option>";
		}else{
    		$options .= "<option value='purple'>Purple</option>";
		}
		if ($message["type"] == "orange"){
    		$options .= "<option value='orange' Selected>Orange</option>";
		}else{
    		$options .= "<option value='orange'>Orange</option>";
		}
    	if ($message["type"] == "light_blue"){
    		$options .= "<option value='light_blue' Selected>Light Blue</option>";
		}else{
    		$options .= "<option value='light_blue'>Light Blue</option>";
		}
		if ($message["index"] == true){
			$radio1 = Array("checked" => 1);
		}else{
			$radio2 = Array("checked" => 1);
		}
    	
    	$table->construct_cell("Położenie: ".$form->generate_radio_button("local","index","Strona główna", $radio1)." ".$form->generate_radio_button("local","whole","Każda strona",$radio2)."<br /> Alert Type: <select name='type'>$options</select>  &nbsp;&nbsp;Kolejność wyświetlania: <select name='order'>".select_order_options($mess[$i]['order'])."</select>",array('class' => 'align_center'));
    	$table->construct_row();    	
    	
    	                        
        $table->construct_cell($form->generate_hidden_field('eid', $message['eid']).
                        	$form->generate_submit_button("Edytuj", array('name' => 'do_edit'))
                        	." ".
                        	$form->generate_reset_button("Zresetuj", array('name' => 'reset'))               
                        	,array('class' => 'align_center'));
                        $table->construct_row();
    	
    $table->output("<center>Emergency Message System</center>");
		
        $form->end();
    }
    
function select_order_options($premade = ""){
	if ($premade == "1" || !$premade){
    	$options .= "<option value='one' Selected>1</option>";
	}else{
    	$options .= "<option value='one'>1</option>";
	}	
	if ($premade == "2"){
    	$options .= "<option value='two' Selected>2</option>";
	}else{
    	$options .= "<option value='two'>2</option>";
	}
	if ($premade == "3"){
    	$options .= "<option value='three' Selected>3</option>";
	}else{
    	$options .= "<option value='three'>3</option>";
	}	
	if ($premade == "4"){
    	$options .= "<option value='four' Selected>4</option>";
	}else{
    	$options .= "<option value='four'>4</option>";
	}	
	if ($premade == "5"){
    	$options .= "<option value='five' Selected>5</option>";
	}else{
    	$options .= "<option value='five'>5</option>";
	}	
	if ($premade == "6"){
    	$options .= "<option value='six' Selected>6</option>";
	}else{
    	$options .= "<option value='six'>6</option>";
	}	
	if ($premade == "7"){
    	$options .= "<option value='seven' Selected>7</option>";
	}else{
    	$options .= "<option value='seven'>7</option>";
	}	
	if ($premade == "2"){
    	$options .= "<option value='eight' Selected>8</option>";
	}else{
    	$options .= "<option value='eight'>8</option>";
	}	
	if ($premade == "2"){
    	$options .= "<option value='nine' Selected>9</option>";
	}else{
    	$options .= "<option value='nine'>9</option>";
	}	
	if ($premade == "2"){
    	$options .= "<option value='ten' Selected>10</option>";
	}else{
    	$options .= "<option value='ten'>10</option>";
	}
	return $options;
}
function revert_nums($value){
   switch($value){
        Case "one":
        	$returner = "1";
        	break;
        Case "two":
        	$returner = "2";
        	break;
        Case "three":
        	$returner = "3";
        	break;
        Case "four":
        	$returner = "4";
        	break;
        Case "five":
        	$returner = "5";
        	break;
        Case "six":
        	$returner = "6";
        	break;
        Case "seven":
        	$returner = "7";
        	break;
        Case "eight":
        	$returner = "8";
        	break;
        Case "nine":
        	$returner = "9";
        	break;
        Case "ten":
        	$returner = "10";
        	break;
	}
	return $returner;
}
?>